# 常用维护项说明

## 历史数据由cvs文件导入数据库
注意：该操作不要直接连接生产环境数据库，在自己本地数据库生成相应数据之后，再导出sql文件，上传到生产环境。

**操作流程如下**

1. 确定本地数据库已创建 

天气服务，所使用的数据配置在schema.json配置文件中，配置项ems。 无需管数据表，表自动创建。

2. 修改配置文件system.properties配置 

修改数据库配置为本地；配置项thread.model值改为false

3. 启动天气服务 

4. 调用读取cvs文件转存数据库接口 

```
接口名：EMS_Weather/Spring/MVC/entrance/unifier/FileData2DB 

参数：
jsonString={
    "dirPath":"D:/wz/cma_2020", 
    "cityList":["WEBY8Q5HHUCU"], 
    "timeFrom":"yyyy-MM-dd HH:mm:ss", 
    "timeTo":"yyyy-MM-dd HH:mm:ss"
} 

说明：
  dirPath为天气历史数据cvs文件所在文件夹目录，必须；
  cityList为需要导入城市的ID，必须，ID可在系统配置文件config/business/cityListData.xlsx中查到;
  timeFrom开始时间数据，非必须，>= 判断
  timeTo结束时间，非必须，< 判断

```

5. 小时数据到日数据（以及日统计数据）计算

```
接口名：EMS_Weather/Spring/MVC/entrance/unifier/HourToDayData 

参数：
jsonString={
    "cityIds":["WW5R9F45BCGR"],
    "startDay":"2017-01-01",
    "endDay":"2020-07-01",
    "type":"All"
}

说明：
  cityIds需要进行由小时数据生成日数据日统计数据的城市id，必须；
  type，除了计算日数据之外，还需要计算的统计值类型，非必须，枚举值：Max,计算最值；Avg计算均值；All最值和均值都计算

```

6. 数据转移

将入库的小时数据，以及计算出的日数据和统计数据，由本地数据库导入到生产环境数据库，**注意，sql文件中不要包含建表、删表语句**

7. 天气数据采集服务记录小时数据

若某一城市需要天气服务今后一直记录小时数据，则需要： 

1）在配置文件config/business/cityListData.xlsx中查到该城市，
将**记录小时天气**列的值改为yes，将**数据字典编码**列填写为对应城市数据字典编码。
修改后将文件改动提交到版本库，提交注释写清改动城市信息。

2）把修改后的cityListData.xlsx文件放到成产环境，天气数据采集服务的相应目录下，然后调用该服务的如下接口

```
接口名：EMS_Weather/Spring/MVC/entrance/unifier/ConfigShow

参数：
jsonString={
    "method":"cache_refresh_all"
}
```
