package com.persagy.ems.pojo.holiday;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.persagy.core.annotation.Column;
import com.persagy.core.annotation.Dimension;
import com.persagy.core.annotation.Entity;
import com.persagy.core.annotation.Table;
import com.persagy.core.enumeration.Schema;
import com.persagy.core.mvc.pojo.BaseId;

@Dimension
@Entity(name = "HolidayGoseek")
@Table(name = "t_holiday_goseek", comment = "法定节假日信息", schema = Schema.EMS)
public class HolidayGoseek extends BaseId {
	private static final long serialVersionUID = 6484225657271639993L;

	@JsonProperty("year")
	@Column(order = 1, name = "c_year", length = 10, nullable = false, comment = "年份")
	private Integer year;

	@Column(order = 10, name = "c_date_time", length = 0, nullable = true, comment = "天时间")
	@JsonProperty("dateTime")
	private Date dateTime;
	
	/** 正常工作日对应结果为 0, 法定节假日对应结果为 1, 节假日调休补班对应的结果为 2 */
	@Column(order = 20, name = "c_code", length = 10, nullable = true, comment = "编码")
	@JsonProperty("code")
	private Integer code;

	@Column(order = 30, name = "c_codestr", length = 100, nullable = true, comment = "编码2")
	@JsonProperty("codeStr")
	private String codeStr;

	public HolidayGoseek() {
		super();
		// TODO Auto-generated constructor stub
	}

	public HolidayGoseek(Integer year, Date dateTime, Integer code) {
		super();
		this.year = year;
		this.dateTime = dateTime;
		this.code = code;
	}
	
	public Integer getYear() {
		return year;
	}

	public void setYear(Integer year) {
		this.year = year;
	}

	public Date getDateTime() {
		return dateTime;
	}

	public void setDateTime(Date dateTime) {
		this.dateTime = dateTime;
	}

	public Integer getCode() {
		return code;
	}

	public void setCode(Integer code) {
		this.code = code;
	}

	public String getCodeStr() {
		return codeStr;
	}

	public void setCodeStr(String codeStr) {
		this.codeStr = codeStr;
	}
}
